//1000,"strcmp.sci","strcmp.sci",1.05,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

#ifndef __STRCMP_SCI__
#define __STRCMP_SCI__

#include "limits.sci"
#include "math.sci"
#include "types.sci"

#define CHARS_ENPL "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define CHARS_DIGI "0123456789"
string CHARS_SPAC = " \t" // najwyszy i rwny priorytet

// private
int lexorderCase( 1 + SCHAR_MAX - SCHAR_MIN )
char lexorderFirstCase, lexorderLastCase

// zwraca pierwszy znak (o najniszej kolejnoci sortowania)
char sub lexorderGetFirst( bool a_case )
	lexorderGetFirst = lexorderFirstCase
endsub

// zwraca ostatni znak (o najwyszej kolejnoci sortowania)
char sub lexorderGetLast( bool a_case )
	lexorderGetLast = lexorderLastCase
endsub

// zwraca porzadek znaku
int sub lexorderGet( char a_c, bool a_case )
	int i
	string s
	if a_c then
		if a_case then
			i = a_c
		else
			s = ucase( using "%c", a_c )
			i = s( 1 )
		endif
		lexorderGet = lexorderCase( 1 - SCHAR_MIN + i ) 
	endif
endsub

// porwnuje stringi
int sub strCmp( string a_s1, string a_s2 )
	int i = 1, iLen1 = len( a_s1 ), iLen2 = len( a_s2 )
	while i <= iLen1 && i <= iLen2
		strCmp = mathISGN( lexorderGet( a_s1( i ), true ) - lexorderGet( a_s2( i ), true ) )
		if strCmp then exit
		i += 1
	wend
	if ! strCmp then strCmp = mathISGN( iLen1 - iLen2 )
endsub

// porwnuje stringi bez case
int sub striCmp( string a_s1, string a_s2 )
	int i = 1, iLen1 = len( a_s1 ), iLen2 = len( a_s2 )
	while i <= iLen1 && i <= iLen2
		striCmp = mathISGN( lexorderGet( a_s1( i ), false ) - lexorderGet( a_s2( i ), false ) )
		if striCmp then exit
		i += 1
	wend
	if ! striCmp then striCmp = mathISGN( iLen1 - iLen2 )
endsub

void sub lexorderInit()
	string sCharOrder
	int i
	char c
	// case sensitive
	// case insensitive: ucase (obsuguje polskie znaki!)
	// i sprowadzam do poprzedniego
	sCharOrder = CHARS_ENPL + lcase( CHARS_ENPL ) + CHARS_DIGI
	// inicjalizuj wszystkie na najnisz rang
	for i = SCHAR_MIN to i > SCHAR_MAX
		lexorderCase( 1 - SCHAR_MIN + i ) = 2 + len( sCharOrder )
	next i
	// zero ma najwysz range 0
	lexorderCase( 1 - SCHAR_MIN + 0 ) = 0
	// teraz wszystkie spacje z rang 1
	for i = 1 to i > len( CHARS_SPAC )
		c = CHARS_SPAC( i )
		lexorderCase( 1 - SCHAR_MIN + c ) = 1
	next i
	// a tu po kolei litery i cyfry z rangami 2 ..
	for i = 1 to i > len( sCharOrder )
		c = sCharOrder( i )
		lexorderCase( 1 - SCHAR_MIN + c ) = 1 + i
	next i
	// teraz najwikszy i najmniejszy znak
	c = sCharOrder( 1 )
	lexorderFirstCase = c
	c = SCHAR_MIN
	while lexorderCase( 1 - SCHAR_MIN + c ) != 2 + len( sCharOrder )
		c += 1
	wend
	lexorderLastCase = c
endsub

lexorderInit()

#endif
